## ncl 6.4.0

=== ncarg2d/src/debugging/VisAreaMapTool/Makefile ===
VisAreaMap.jar:  
	javac edu/ucar/vets/VisualAreaMapTool.java
	jar cvfe VisAreaMap.jar edu.ucar.vets.VisualAreaMapTool edu

clean:
	rm -f edu/ucar/vets/*.class
	rm VisAreaMap.jar

## ncl 6.1.2

=== debian/changelog ===
ncl (6.1.2-7) unstable; urgency=medium

  * Add support for kFreeBSD, Hurd to support-archs.patch 
  * Add support for aarch64 to support-archs.patch. Closes: #742467.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 03 Mar 2014 11:02:41 +0000

ncl (6.1.2-6) unstable; urgency=medium

  * proj library not needed. Drop references in config/Project.
  * Fix library references and refactor patches to fix FTBFS.
    Closes: #733003.
  * Fix bash_completion.d ; wrong file installed. 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 28 Feb 2014 15:56:27 +0000

ncl (6.1.2-5) unstable; urgency=medium

  * Don't redirect output to tty in ymake; breaks on FreeBSD, not 
    guaranteed anywhere.
  * Build executables with shared libraries, fPIC as otherwise fPIE doesn't
    work on amd64.
  * Add flex, bison build-dependencies to generate wrapit.  
  * Build by setting RootPath rather than $(DESTDIR)

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 12 Jan 2014 10:22:17 +0000

ncl (6.1.2-4) unstable; urgency=medium

   * Enforce building libraries first, as build-order via makefile
     not reliable.
  * Add -I/usr/include/mpi when building when libhdf-mpi-dev rather than
    serial. 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 03 Jan 2014 11:40:02 +0000

ncl (6.1.2-3) unstable; urgency=medium

  * Depend on gfortran, libxt-dev
  * Add dependency on fonts-lyx for cms*ttf fonts, rather than shipping them. 
  * tty_patch: don't use /dev/tty directly in ymake as it breaks on kFreeBSD.
  * manpages_patch: Fix (some) lintian warnings on whatis entries, hyphens
    More to do next year.
  * link_pie_prog.patch: Link Programs with -fPIE, immediate binding, 
    for hardening.
  * Add sonames, hardening to shared libraries.
  * Now needs security.patch to fix false alarms after hardening enabled.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 30 Dec 2013 19:41:22 +0000

ncl (6.1.2-2) unstable; urgency=medium

  * Add tcsh | csh | c-shell as Build-Dependency. Closes: #733033.
    Also as dep for binary packages.
  * Label libncarg-data as Multi-Arch: foreign. 
  * Move to Standards-Version: 3.9.5. No changes required. 
  * libncarg-bin is now Multi-Arch: foreign

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 30 Dec 2013 16:29:09 +0000

ncl (6.1.2-1) unstable; urgency=low

  * Initial release. (Closes: #531982)

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 02 Oct 2013 01:31:40 +0000

=== debian/control ===
Source: ncl
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: flex, bison, gfortran, zlib1g-dev, libbz2-dev, libxt-dev, libxaw7-dev, libxmu-headers, libcairo2-dev, libjpeg8-dev, libpng12-dev, pkg-config, fontconfig, libfontconfig1-dev, libfreetype6-dev, libexpat1-dev, libpixman-1-dev,  libcurl4-gnutls-dev | libcurl-dev,  libgdal1-dev, libnetcdf-dev, libudunits2-dev, liblapack-dev, libblas-dev, libgrib2c-dev, libsphere-dev, libhdf4-alt-dev, libhdfeos-dev, libgctp-dev, libhe5-hdfeos-dev, tcsh | csh | c-shell, debhelper (>= 9), libhdf5-serial-dev | libhdf5-dev
Standards-Version: 3.9.5
Homepage: http://www.ncl.ucar.edu/

Package: ncl-ncarg
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, tcsh | csh | c-shell
Description: NCAR Command Language and NCAR graphics
 The NCAR Command Language (NCL) is a free interpreted language designed
 specifically for scientific data processing and visualization. NCL has robust
 file input and output. It can read and write netCDF-3, netCDF-4 classic
 HDF4, HDF5, binary, and ASCII data, and read HDF-EOS2, GRIB1 and
 GRIB2. The graphics are world class and highly customizable.
 .
 The software comes with a couple of useful command line tools:
 * ncl_filedump - prints the contents of supported files (netCDF, HDF,
   GRIB1, GRIB2, HDF-EOS2, and CCM History Tape)
 * ncl_convert2nc - converts one or more GRIB1, GRIB2, HDF and/or HDF-EOS
   iles to netCDF formatted files.

Package: libncarg0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libudunits2-0, ttf-bitstream-vera, fonts-lyx, libncarg-data, tcsh | csh | c-shell
Recommends: libncarg-bin, pkg-config
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: NCAR command-language library
 NCAR Command Language library used by NCAR binaries and tools.

Package: libncarg-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libncarg0 (= ${binary:Version} ), libxgks-dev, libudunits2-dev
Multi-Arch: same
Description: Development files for the NCAR command language library
 ncarg is the NCAR command-language. 

Package: libncarg-bin
Architecture: any
Depends: ${misc:Depends}, libncarg-dev (= ${binary:Version} ), ${shlibs:Depends}, tcsh | csh | c-shell
Multi-Arch: foreign
Description: NCAR command-language library - development tools
 This package provides development tools for developing applications of the 
 NCARG command library, such as wrappers for compilation of NCL executables.

Package: libncarg-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: NCAR command-language library - Data
 NCAR Command Language library used by NCAR. This package contains data such
 as colormaps, fonts and map data that is used by the ncarg library.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# The magic debhelper  rule
%:
	dh $@ 

TOPDIR:=$(shell pwd)
DESTDIR:=$(TOPDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

# For the config file. Done this way to pull in stuff from hardening, etc.
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
# LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
LDFLAGS:= 
FFLAGS:=$(shell dpkg-buildflags --get FFLAGS)
CC ?= cc
FC := gfortran
VERSION := 6.1.2

export LD_LIBRARY_PATH=$(TOPDIR)/shared:$(LIBDIR)/libfakeroot

# We built it twice: first shared, to get the shared libraries (with -fpic -fPIC)
# then static, for execution speed.

LIBS:= \
	libNGcgm.so  libNGctrans.so   libNGgksPDF.so  libNGgksX.so     libNGlluC.so  libNGmisc2.so  libNGncl.so \
	libNGcn.so   libNGff.so       libNGgksPS.so   libNGhlu.so      libNGllu.so   libNGmisc.so   libNGnfp.so \
	libNGc.so    libNGgksCTXT.so  libNGgks.so     libNGictrans.so  libNGmath.so  libNGmp.so     libNGras.so \
	libfftpack5_dp.so libsphere3.1_dp.so libNGnfpfort.so

# Add extra libs to ensure all shared libs link
EXTRA_LIBS:= -lpng -lz -lX11 -lcairo

# This done here to avoid subsitution bug on broken ymake buildsystem
INCS="-I/usr/include/freetype2 -I/usr/include/gdal  -I/usr/include/hdf-eos5 -I/usr/include/hdf -I/usr/include/${DEB_HOST_MULTIARCH}/hdf -I/usr/include/mpi"

override_dh_auto_configure:
	sed -e 's,@LIBDIR@,$(LIBDIR),' \
	    -e 's/@PREFIX@/\/usr/' \
	    -e 's/@VERSION@/$(VERSION)/' \
	< debian/ncarg.pc.in > ncarg.pc
	sed -e 's/@CC@/${CC}/' \
	    -e 's/@FC@/${FC}/' \
	    -e 's/@LD@/${CC}/' \
	    -e 's/@CFLAGS@/${CFLAGS}/' \
	    -e 's/@FFLAGS@/${FFLAGS}/' \
	    -e 's/@CPPFLAGS@/${CPPFLAGS}/' \
	    -e 's/@LDFLAGS@/${LDFLAGS}/' \
	    -e 's%@DESTDIR@%${DESTDIR}%' \
	< debian/Site.local.shared.in > config/Site.local.shared
	sed -e 's/@CC@/${CC}/' \
	    -e 's/@FC@/${FC}/' \
	    -e 's/@LD@/${CC}/' \
	    -e 's/@CFLAGS@/${CFLAGS}/' \
	    -e 's/@FFLAGS@/${FFLAGS}/' \
	    -e 's/@CPPFLAGS@/${CPPFLAGS}/' \
	    -e 's/@LDFLAGS@/${LDFLAGS}/' \
	    -e 's%@DESTDIR@%${DESTDIR}%' \
	< debian/Site.local.static.in > config/Site.local.static

override_dh_auto_build:
	# Static libraries need to be built first
	cp debian/LINUX.DEBIAN config/LINUX
	cp config/Site.local.static config/Site.local
	echo 'n' | ./Configure -v
	$(MAKE) Makefiles includes depend
	for d in common external ngmath/src/lib ncarg2d/src/libncarg_gks ncarg2d/src/libncarg ncarg2d/src/liboptional  ncarview ni/src/lib ; do \
		$(MAKE) -C $$d install INCSEARCH=${INCS} INC_SEARCH=${INCS} ; done
	$(MAKE) install INCSEARCH=${INCS} INC_SEARCH=${INCS} 
	# Install them safely in $(DESTDIR) as originals will be removed making shared libs
	mkdir -p $(DESTDIR)/staticlibs
	mv $(DESTDIR)/lib/*.a $(DESTDIR)/staticlibs
	$(MAKE) clean
	find . -name '*.[o]' -delete
	# Shared libraries next, in the right order.
	cp config/Site.local.shared config/Site.local
	echo 'n' | ./Configure -v
	$(MAKE) Makefiles includes depend
	for d in common external ngmath/src/lib ncarg2d/src/libncarg_gks ncarg2d/src/libncarg ncarg2d/src/liboptional  ncarview ni/src/lib ; do \
		LD_LIBRARY_PATH=$(TOPDIR)/debian/tmp/lib:$(TOPDIR)/shared $(MAKE) -C $$d install \
			DEV_SYS_LIBS=$(EXTRA_LIBS)   INCSEARCH=${INCS} INC_SEARCH=${INCS}; done
	# Then build all the rest
	LD_LIBRARY_PATH=$(TOPDIR)/debian/tmp/lib:$(TOPDIR)/shared $(MAKE) Everything \
		DEV_SYS_LIBS=$(EXTRA_LIBS) INCSEARCH=${INCS} INC_SEARCH=${INCS}
	mv $(DESTDIR)/staticlibs/* $(DESTDIR)/lib

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/libncarg-dev/$(LIBDIR)
	cp debian/tmp/lib/*.a debian/libncarg-dev/$(LIBDIR)
	mkdir -p debian/libncarg0/$(LIBDIR)
	cp shared/*.so.1 debian/libncarg0/$(LIBDIR)
	mkdir -p  debian/libncarg-dev/$(LIBDIR)/pkgconfig
	cp ncarg.pc debian/libncarg-dev/$(LIBDIR)/pkgconfig
	for d in $(LIBS) ; do \
		dh_link -p libncarg-dev $(LIBDIR)/$$d.1 $(LIBDIR)/$$d ; done 
	mkdir -p debian/libncarg0/$(LIBDIR)
	mkdir -p debian/libncarg-dev/$(LIBDIR)/ncarg
	for d in $(LIBS) ; do \
		cp shared/$$d debian/libncarg0/$(LIBDIR)/$$d.1 ; \
		dh_link -p libncarg-dev $(LIBDIR)/$$d.1 $(LIBDIR)/$$d ;  done
	cp -a debian/tmp/lib/ncarg/robj debian/libncarg-dev/$(LIBDIR)/ncarg

override_dh_auto_clean:
	find . -name '*.so.1' -delete
	find . -type l -delete
	find . -name '*.o' -delete
	rm -f ncarg.pc config/Site.local.*
ifneq ($(wildcard config/LINUX.ORIG),)
	mv config/LINUX.ORIG config/LINUX
endif

## ncl 6.2.0

=== debian/changelog ===
ncl (6.2.0-3) unstable; urgency=medium

  * Change libjpeg8 -> libjpeg in debian/control. Closes: #763485.
  * Now at Standards-Version: 3.9.6

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 10 Oct 2014 07:46:56 +0100

ncl (6.2.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Support hdf5 1.8.13 new packaging layout (closes: #756686).

 -- Gilles Filippini <pini@debian.org>  Tue, 05 Aug 2014 19:56:38 +0200

ncl (6.2.0-2) unstable; urgency=medium

  * libproj-dev now needed explicitly. 

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 28 Jul 2014 21:07:13 +0100

ncl (6.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Build sphere3.1_dp first to ensure its always present when needed.
    Closes: #753231.
  * Build with atlas rather than base lapack, blas.
  * Use xz compression.
  * Add symlink $NCARG_ROOT/lib/ncarg -> /usr/share/ncarg fix references
    in scripts to non-FHS directory locations.  LP: #1329691.
  * Patch needed for compiler issue under examination in _NGResolvePath()
    compiler_fix.patch.

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 27 Jul 2014 13:05:44 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,17 @@
 Section: science
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: flex, bison, gfortran, zlib1g-dev, libbz2-dev, libxt-dev, libxaw7-dev, libxmu-headers, libcairo2-dev, libjpeg8-dev, libpng12-dev, pkg-config, fontconfig, libfontconfig1-dev, libfreetype6-dev, libexpat1-dev, libpixman-1-dev,  libcurl4-gnutls-dev | libcurl-dev,  libgdal1-dev, libnetcdf-dev, libudunits2-dev, liblapack-dev, libblas-dev, libgrib2c-dev, libsphere-dev, libhdf4-alt-dev, libhdfeos-dev, libgctp-dev, libhe5-hdfeos-dev, tcsh | csh | c-shell, debhelper (>= 9), libhdf5-serial-dev | libhdf5-dev
-Standards-Version: 3.9.5
+Build-Depends: flex, bison, gfortran, zlib1g-dev, libbz2-dev, libxt-dev,
+ libxaw7-dev, libxmu-headers, libcairo2-dev, libjpeg-dev, libpng12-dev,
+ pkg-config, fontconfig, libfontconfig1-dev, libfreetype6-dev, libexpat1-dev,
+ libpixman-1-dev,  libcurl4-gnutls-dev | libcurl-dev,  libgdal1-dev,
+ libnetcdf-dev, libudunits2-dev,
+ libatlas-dev, liblapack-dev, libblas-dev, libatlas3-base,
+ libgrib2c-dev, libsphere-dev, libhdf4-alt-dev, libhdfeos-dev,
+ libgctp-dev, libhe5-hdfeos-dev, tcsh | csh | c-shell,
+ debhelper (>= 9), libhdf5-serial-dev | libhdf5-dev,
+ libproj-dev
+Standards-Version: 3.9.6
 Homepage: http://www.ncl.ucar.edu/
 
 Package: ncl-ncarg

=== debian/rules ===
--- 
+++ 
@@ -20,6 +20,11 @@
 CC ?= cc
 FC := gfortran
 VERSION := 6.1.2
+
+ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
+  CFLAGS += -I/usr/include/hdf5/serial
+  export HDF5_LDFLAGS := -Wl,-L/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
+endif
 
 export LD_LIBRARY_PATH=$(TOPDIR)/shared:$(LIBDIR)/libfakeroot
 
@@ -46,7 +51,7 @@
 	sed -e 's/@CC@/${CC}/' \
 	    -e 's/@FC@/${FC}/' \
 	    -e 's/@LD@/${CC}/' \
-	    -e 's/@CFLAGS@/${CFLAGS}/' \
+	    -e 's:@CFLAGS@:${CFLAGS}:' \
 	    -e 's/@FFLAGS@/${FFLAGS}/' \
 	    -e 's/@CPPFLAGS@/${CPPFLAGS}/' \
 	    -e 's/@LDFLAGS@/${LDFLAGS}/' \
@@ -55,7 +60,7 @@
 	sed -e 's/@CC@/${CC}/' \
 	    -e 's/@FC@/${FC}/' \
 	    -e 's/@LD@/${CC}/' \
-	    -e 's/@CFLAGS@/${CFLAGS}/' \
+	    -e 's:@CFLAGS@:${CFLAGS}:' \
 	    -e 's/@FFLAGS@/${FFLAGS}/' \
 	    -e 's/@CPPFLAGS@/${CPPFLAGS}/' \
 	    -e 's/@LDFLAGS@/${LDFLAGS}/' \
@@ -63,6 +68,11 @@
 	< debian/Site.local.static.in > config/Site.local.static
 
 override_dh_auto_build:
+	# First do spherepack. (Later replace this with external spherepack)
+	cp config/Site.local.shared config/Site.local
+	echo 'n' | ./Configure -v
+	$(MAKE) Makefiles includes depend
+	$(MAKE) -C external/sphere3.1_dp install INCSEARCH=${INCS} INC_SEARCH=${INCS}
 	# Static libraries need to be built first
 	cp debian/LINUX.DEBIAN config/LINUX
 	cp config/Site.local.static config/Site.local

## ncl 6.3.0

=== debian/changelog ===
ncl (6.3.0-8b2) staging; urgency=medium

  * No-change rebuild against libpng16-16.

 -- Tanglu AutoRebuilder <dak-rebuild@ftp-master.tanglu.org>  Sun, 15 May 2016 18:50:50 +0200

ncl (6.3.0-8b1) staging; urgency=medium

  * No-change rebuild against libpng16-16.

 -- Tanglu AutoRebuilder <dak-rebuild@ftp-master.tanglu.org>  Sat, 14 May 2016 19:26:48 +0200

ncl (6.3.0-8) unstable; urgency=medium

  * Rebuild against libgdal-dev for gdal2.0 transition

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 02 Mar 2016 07:50:52 +0000

ncl (6.3.0-7) unstable; urgency=medium

  * Add -lsz to the static libraries needed in ncarg.pc
  * Move libncl.a to $LIBDIR/ncarg/libncl.a. Closes: #813972.
  * Change ncargpath lib to $LIBDIR/ncarg and add .so
  * Change $lib to /usr/lib/$arch/ncarg in config/Project
  * Add B-D on libmotif-dev for Motif support.
  * Standards-Version: 3.9.7. No changes required
  * Drop linking against jasper as it is being removed from Debian.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 29 Feb 2016 21:01:26 +0000

ncl (6.3.0-6) unstable; urgency=medium

  * Typo in depends: ncl-narg -> ncl-ncarg. Closes: #810682.

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 10 Jan 2016 15:40:31 +0000

ncl (6.3.0-5) unstable; urgency=medium

  * Build with libpng-dev. Closes: #810193.
  * B-D on libaec-dev, link against libsz for szip compression
  * libncarg-dev should depend on ncl-ncarg for ncargpath.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 07 Jan 2016 06:53:52 +0000

ncl (6.3.0-4) unstable; urgency=medium

  * reproducible.patch: remove timestamps to make build reproducible

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 21 Nov 2015 11:57:25 +0000

ncl (6.3.0-4~exp2) experimental; urgency=medium

  * Move /etc/bash_completions.d/* to new /usr/share/bash_completions 
  * Install DEBIAN link earlier before configuration.
  * Remove '-ansi' to fix FTBFS on mips*.
 
 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 24 Aug 2015 16:25:19 +0100

ncl (6.3.0-4~exp1) experimental; urgency=medium

   * Install DEBIAN config file correctly for building on non-Linux systems.
   * Build against hdf-eos4 what uses libhdf4-alt-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 17 Aug 2015 04:18:15 +0100

ncl (6.3.0-3) experimental; urgency=medium

  * Enable libnetcdff-dev for transition

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 28 Jul 2015 17:22:17 +0100

ncl (6.3.0-3~exp1) unstable; urgency=medium

  * Use canonical anonscm.debian.org URL scheme. 
  * Update VERSION to 6.3.0 in debian/rules

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 15 Jul 2015 10:05:22 +0100

ncl (6.3.0-2) unstable; urgency=medium

  * Build-Depend on libgdal-dev not libgdal1-dev, for gdal-2.0.0 transition.
    Closes: #789489
  * Add Vcs-Git: to debian/control; debian-science repo. 

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 21 Jun 2015 15:33:45 +0100

ncl (6.3.0-1) unstable; urgency=medium

  * New upstream release
  * security.patch: removed, changes now upstream
  * deblibs patch from  Tyson Whitehead for Missing text on plots.
    Closes: #787652
  * Include PlotcharData in libncarg-data package. Closes: #785547

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 20 Jun 2015 20:50:24 +0100

=== debian/control ===
--- 
+++ 
@@ -3,17 +3,18 @@
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: flex, bison, gfortran, zlib1g-dev, libbz2-dev, libxt-dev,
- libxaw7-dev, libxmu-headers, libcairo2-dev, libjpeg-dev, libpng12-dev,
+ libxaw7-dev, libxmu-headers, libcairo2-dev, libjpeg-dev, libpng-dev,
  pkg-config, fontconfig, libfontconfig1-dev, libfreetype6-dev, libexpat1-dev,
- libpixman-1-dev,  libcurl4-gnutls-dev | libcurl-dev,  libgdal1-dev,
- libnetcdf-dev, libudunits2-dev,
+ libpixman-1-dev,  libcurl4-gnutls-dev | libcurl-dev,  libgdal-dev,
+ libnetcdf-dev, libnetcdff-dev, libudunits2-dev, libmotif-dev,
  libatlas-dev, liblapack-dev, libblas-dev, libatlas3-base,
  libgrib2c-dev, libsphere-dev, libhdf4-alt-dev, libhdfeos-dev,
  libgctp-dev, libhe5-hdfeos-dev, tcsh | csh | c-shell,
  debhelper (>= 9), libhdf5-serial-dev | libhdf5-dev,
- libproj-dev
-Standards-Version: 3.9.6
+ libproj-dev, libaec-dev
+Standards-Version: 3.9.7
 Homepage: http://www.ncl.ucar.edu/
+Vcs-Git: git://anonscm.debian.org/debian-science/packages/ncl.git
 
 Package: ncl-ncarg
 Architecture: any
@@ -44,7 +45,7 @@
 Package: libncarg-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libncarg0 (= ${binary:Version} ), libxgks-dev, libudunits2-dev
+Depends: ${misc:Depends}, libncarg0 (= ${binary:Version} ), libxgks-dev, libudunits2-dev, ncl-ncarg
 Multi-Arch: same
 Description: Development files for the NCAR command language library
  ncarg is the NCAR command-language.

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,7 @@
 FFLAGS:=$(shell dpkg-buildflags --get FFLAGS)
 CC ?= cc
 FC := gfortran
-VERSION := 6.1.2
+VERSION := 6.3.0
 
 ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
   CFLAGS += -I/usr/include/hdf5/serial
@@ -66,15 +66,20 @@
 	    -e 's/@LDFLAGS@/${LDFLAGS}/' \
 	    -e 's%@DESTDIR@%${DESTDIR}%' \
 	< debian/Site.local.static.in > config/Site.local.static
+	sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%' \
+	< config/Project > config/Project.post
+	mv config/Project.post config/Project 
 
 override_dh_auto_build:
 	# First do spherepack. (Later replace this with external spherepack)
 	cp config/Site.local.shared config/Site.local
 	echo 'n' | ./Configure -v
+	cp debian/LINUX.DEBIAN config/LINUX
+	ln -sf LINUX config/DEBIAN
 	$(MAKE) Makefiles includes depend
 	$(MAKE) -C external/sphere3.1_dp install INCSEARCH=${INCS} INC_SEARCH=${INCS}
 	# Static libraries need to be built first
-	cp debian/LINUX.DEBIAN config/LINUX
+	# Add symlink for non-Linux archs
 	cp config/Site.local.static config/Site.local
 	echo 'n' | ./Configure -v
 	$(MAKE) Makefiles includes depend
@@ -100,8 +105,9 @@
 
 override_dh_auto_install:
 	dh_auto_install
-	mkdir -p debian/libncarg-dev/$(LIBDIR)
-	cp debian/tmp/lib/*.a debian/libncarg-dev/$(LIBDIR)
+	mkdir -p debian/libncarg-dev/$(LIBDIR)/ncarg
+	rm debian/tmp/lib/libblas_ncl.a debian/tmp/lib/liblapack_ncl.a
+	cp debian/tmp/lib/*.a debian/libncarg-dev/$(LIBDIR)/ncarg
 	mkdir -p debian/libncarg0/$(LIBDIR)
 	cp shared/*.so.1 debian/libncarg0/$(LIBDIR)
 	mkdir -p  debian/libncarg-dev/$(LIBDIR)/pkgconfig
@@ -119,7 +125,7 @@
 	find . -name '*.so.1' -delete
 	find . -type l -delete
 	find . -name '*.o' -delete
-	rm -f ncarg.pc config/Site.local.*
+	rm -f ncarg.pc config/Site.local.* config/DEBIAN
 ifneq ($(wildcard config/LINUX.ORIG),)
 	mv config/LINUX.ORIG config/LINUX
 endif

## ncl 6.4.0

=== debian/changelog ===
ncl (6.4.0-9) unstable; urgency=medium

  * Fix FTBFBS ;  condition giving error exit. Closes: #892311

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 09 Mar 2018 08:22:47 +0000

ncl (6.4.0-8) unstable; urgency=medium

  * Temporarily conditionally install some optional files that may not be
    built on mips64el. Closes: #892154

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 Mar 2018 06:50:07 +0000

ncl (6.4.0-7) unstable; urgency=medium

  * Fix regression on supported-archs.patch for mips, s390

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 04 Mar 2018 18:09:17 +0000

ncl (6.4.0-6) unstable; urgency=medium

  * Default to libblas-dev, not libopenblas-dev, as it makes many archs
    unnstallable.

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 04 Mar 2018 09:02:58 +0000

ncl (6.4.0-5) unstable; urgency=medium

  * Use libhdf5-dev instead of transitional libhdf5-serial-dev
  * Standards-Version: 4.1.3; no changes required
  * Use libopenblas on more archs as available
  * Fix needed for hppa, kfreebsd (+hppa?) support. Closes: #850104
  * Move VCS to salsa.debian.org
  * Remove obsolete compiler-fix.patch

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 02 Mar 2018 17:09:59 +0000

ncl (6.4.0-4) unstable; urgency=medium

  * Drop libatlas-dev build-depend. Closes: #871715
  * Standards-Version: 4.0.1

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 11 Aug 2017 11:44:18 +0100

ncl (6.4.0-3) unstable; urgency=medium

  * Set ncl-ncarg as Multi-Arch: foreign
  * Fix manpage errors (thanks Lint.)  
  * Set ksh paths to /bin/ksh in scripts. (ksh.patch)
  * Ensure all ksh scripts are executable
  * Move all ksh scripts to libncarg-dev examples (not -data package)

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 31 Jul 2017 16:26:39 +0100

ncl (6.4.0-2) experimental; urgency=medium

  * Fix version number in pc file
  * Standards-Version: 4.0.0; no changes required
  * Add gbp.conf file
  * Debhelper compat=10
  * Patch: ensure triple2grid.f compiled -fPIC

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 31 Jul 2017 12:22:31 +0100

ncl (6.4.0-1) experimental; urgency=medium

  * New upstream release
     - Patch needed to not link explicitly to libiconv
  * Add libgdl-dev build-dependency

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 18 Apr 2017 16:11:56 +0100

ncl (6.3.0-13) unstable; urgency=medium

  * Add ncl Desktop, icon files

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 23 Dec 2016 15:09:13 +0000

ncl (6.3.0-12) unstable; urgency=medium

  * Add libfl-dev as B-D as flex no longer depends on it. Closes: #846444

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 02 Dec 2016 09:22:12 +0000

ncl (6.3.0-11) unstable; urgency=medium

  * Conditionally depend on openblas. Closes: #86191

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 31 Aug 2016 12:03:52 +0100

ncl (6.3.0-10) unstable; urgency=medium

  * Preferentially use openblas not blas
  * Allow -fdebug-prefix-map in CFLAGS (change sed in rules). Closes: #832011

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 14 Aug 2016 10:33:28 +0100

ncl (6.3.0-9) unstable; urgency=medium

  * Fix udunits path. Closes: #829702
  * Standards-Version: 3.9.8. No changes required.
  * Ack. previously fixed bug. Closes: #809716.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 18 Jul 2016 14:33:25 +0100

=== debian/control ===
--- 
+++ 
@@ -2,22 +2,48 @@
 Section: science
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: flex, bison, gfortran, zlib1g-dev, libbz2-dev, libxt-dev,
+Build-Depends: debhelper (>= 10), 
+ flex, 
+ bison, 
+ gfortran, 
+ zlib1g-dev, 
+ libbz2-dev, 
+ libxt-dev,
  libxaw7-dev, libxmu-headers, libcairo2-dev, libjpeg-dev, libpng-dev,
- pkg-config, fontconfig, libfontconfig1-dev, libfreetype6-dev, libexpat1-dev,
- libpixman-1-dev,  libcurl4-gnutls-dev | libcurl-dev,  libgdal-dev,
- libnetcdf-dev, libnetcdff-dev, libudunits2-dev, libmotif-dev,
- libatlas-dev, liblapack-dev, libblas-dev, libatlas3-base,
- libgrib2c-dev, libsphere-dev, libhdf4-alt-dev, libhdfeos-dev,
- libgctp-dev, libhe5-hdfeos-dev, tcsh | csh | c-shell,
- debhelper (>= 9), libhdf5-serial-dev | libhdf5-dev,
- libproj-dev, libaec-dev
-Standards-Version: 3.9.7
-Homepage: http://www.ncl.ucar.edu/
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/ncl.git
+ pkg-config, 
+ fontconfig, 
+ libfontconfig1-dev, 
+ libfreetype6-dev, 
+ libexpat1-dev,
+ libpixman-1-dev,  
+ libcurl4-gnutls-dev | libcurl-dev,  
+ libgdal-dev,
+ libnetcdf-dev, 
+ libnetcdff-dev, 
+ libudunits2-dev, 
+ libmotif-dev,
+ libatlas3-base,
+ liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
+ libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
+ libgrib2c-dev, 
+ libsphere-dev, 
+ libhdf4-alt-dev, 
+ libhdfeos-dev,
+ libgctp-dev, 
+ libhe5-hdfeos-dev, tcsh | csh | c-shell,
+ libhdf5-dev | libhdf5-mpi-dev,
+ libproj-dev, 
+ libaec-dev,
+ libfl-dev, 
+ libgsl-dev
+Standards-Version: 4.1.3
+Homepage: https://www.ncl.ucar.edu/
+Vcs-Browser: https://salsa.debian.org:/science-team/ncl.git
+Vcs-Git: https://salsa.debian.org:/science-team/ncl.git
 
 Package: ncl-ncarg
 Architecture: any
+Multi-Arch: foreign
 Depends: ${misc:Depends}, ${shlibs:Depends}, tcsh | csh | c-shell
 Description: NCAR Command Language and NCAR graphics
  The NCAR Command Language (NCL) is a free interpreted language designed
@@ -45,7 +71,8 @@
 Package: libncarg-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libncarg0 (= ${binary:Version} ), libxgks-dev, libudunits2-dev, ncl-ncarg
+Depends: ${misc:Depends}, libncarg0 (= ${binary:Version} ), libxgks-dev, libudunits2-dev,
+ ncl-ncarg, ksh | mksh | pdksh | zsh
 Multi-Arch: same
 Description: Development files for the NCAR command language library
  ncarg is the NCAR command-language.

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,7 @@
 FFLAGS:=$(shell dpkg-buildflags --get FFLAGS)
 CC ?= cc
 FC := gfortran
-VERSION := 6.3.0
+VERSION := 6.4.0
 
 ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
   CFLAGS += -I/usr/include/hdf5/serial
@@ -48,22 +48,22 @@
 	    -e 's/@PREFIX@/\/usr/' \
 	    -e 's/@VERSION@/$(VERSION)/' \
 	< debian/ncarg.pc.in > ncarg.pc
-	sed -e 's/@CC@/${CC}/' \
-	    -e 's/@FC@/${FC}/' \
-	    -e 's/@LD@/${CC}/' \
-	    -e 's:@CFLAGS@:${CFLAGS}:' \
-	    -e 's/@FFLAGS@/${FFLAGS}/' \
-	    -e 's/@CPPFLAGS@/${CPPFLAGS}/' \
-	    -e 's/@LDFLAGS@/${LDFLAGS}/' \
+	sed -e 's%@CC@%${CC}%' \
+	    -e 's%@FC@%${FC}%' \
+	    -e 's%@LD@%${CC}%' \
+	    -e 's%@CFLAGS@%${CFLAGS}%' \
+	    -e 's%@FFLAGS@%${FFLAGS}%' \
+	    -e 's%@CPPFLAGS@%${CPPFLAGS}%' \
+	    -e 's%@LDFLAGS@%${LDFLAGS}%' \
 	    -e 's%@DESTDIR@%${DESTDIR}%' \
 	< debian/Site.local.shared.in > config/Site.local.shared
-	sed -e 's/@CC@/${CC}/' \
-	    -e 's/@FC@/${FC}/' \
-	    -e 's/@LD@/${CC}/' \
-	    -e 's:@CFLAGS@:${CFLAGS}:' \
-	    -e 's/@FFLAGS@/${FFLAGS}/' \
-	    -e 's/@CPPFLAGS@/${CPPFLAGS}/' \
-	    -e 's/@LDFLAGS@/${LDFLAGS}/' \
+	sed -e 's%@CC@%${CC}%' \
+	    -e 's%@FC@%${FC}%' \
+	    -e 's%@LD@%${CC}%' \
+	    -e 's%@CFLAGS@%${CFLAGS}%' \
+	    -e 's%@FFLAGS@%${FFLAGS}%' \
+	    -e 's%@CPPFLAGS@%${CPPFLAGS}%' \
+	    -e 's%@LDFLAGS@%${LDFLAGS}%' \
 	    -e 's%@DESTDIR@%${DESTDIR}%' \
 	< debian/Site.local.static.in > config/Site.local.static
 	sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%' \
@@ -73,9 +73,9 @@
 override_dh_auto_build:
 	# First do spherepack. (Later replace this with external spherepack)
 	cp config/Site.local.shared config/Site.local
-	echo 'n' | ./Configure -v
 	cp debian/LINUX.DEBIAN config/LINUX
 	ln -sf LINUX config/DEBIAN
+	echo 'n' | ./Configure -v
 	$(MAKE) Makefiles includes depend
 	$(MAKE) -C external/sphere3.1_dp install INCSEARCH=${INCS} INC_SEARCH=${INCS}
 	# Static libraries need to be built first
@@ -106,7 +106,11 @@
 override_dh_auto_install:
 	dh_auto_install
 	mkdir -p debian/libncarg-dev/$(LIBDIR)/ncarg
-	rm debian/tmp/lib/libblas_ncl.a debian/tmp/lib/liblapack_ncl.a
+	# rm debian/tmp/lib/libblas_ncl.a debian/tmp/lib/liblapack_ncl.a
+	# TODO: These may not be present on mips64el. 
+	mkdir -p debian/libncarg-data/usr/share/ncarg/nug
+	[ -d debian/tmp/lib/ncarg/fontcaps ] && cp -a debian/tmp/lib/ncarg/fontcaps debian/libncarg-data/usr/share/ncarg || true
+	[ -d debian/tmp/lib/ncarg/nclex/nug  ] && cp -a debian/tmp/lib/ncarg/nclex/nug debian/libncarg-data/usr/share/ncarg/nug || true
 	cp debian/tmp/lib/*.a debian/libncarg-dev/$(LIBDIR)/ncarg
 	mkdir -p debian/libncarg0/$(LIBDIR)
 	cp shared/*.so.1 debian/libncarg0/$(LIBDIR)
@@ -120,6 +124,7 @@
 		cp shared/$$d debian/libncarg0/$(LIBDIR)/$$d.1 ; \
 		dh_link -p libncarg-dev $(LIBDIR)/$$d.1 $(LIBDIR)/$$d ;  done
 	cp -a debian/tmp/lib/ncarg/robj debian/libncarg-dev/$(LIBDIR)/ncarg
+	find debian -name '*.ksh' -exec chmod +x {} \;
 
 override_dh_auto_clean:
 	find . -name '*.so.1' -delete

## ncl 6.5.0

=== debian/changelog ===
ncl (6.5.0-2) unstable; urgency=medium

  * Standards-Version: 4.3.0
  * Ship *.names files in libncarg-data. LP: #1808217
  * Sanitise build paths in scripts for bit-reprodubcibility

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 20 Jan 2019 09:46:03 +0000

ncl (6.5.0-1) unstable; urgency=medium

  * New upstream release
  * Add watch file.
  * Standards-Version: 4.2.1
  * Add ksh dependenccy to libncarg-data
  * Remove obsolete Pre-Depends on lib package

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 25 Nov 2018 13:58:35 +0000

ncl (6.4.0-10) unstable; urgency=medium

  * Standards-Version: 4.1.4
  * Build against libgctp-2.0.0

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 02 Jun 2018 10:42:20 +0100

=== debian/control ===
--- 
+++ 
@@ -30,13 +30,14 @@
  libhdf4-alt-dev, 
  libhdfeos-dev,
  libgctp-dev, 
- libhe5-hdfeos-dev, tcsh | csh | c-shell,
+ libhe5-hdfeos-dev,
+ tcsh | csh | c-shell,
  libhdf5-dev | libhdf5-mpi-dev,
  libproj-dev, 
  libaec-dev,
  libfl-dev, 
  libgsl-dev
-Standards-Version: 4.1.3
+Standards-Version: 4.3.0
 Homepage: https://www.ncl.ucar.edu/
 Vcs-Browser: https://salsa.debian.org:/science-team/ncl.git
 Vcs-Git: https://salsa.debian.org:/science-team/ncl.git
@@ -63,7 +64,6 @@
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}, libudunits2-0, ttf-bitstream-vera, fonts-lyx, libncarg-data, tcsh | csh | c-shell
 Recommends: libncarg-bin, pkg-config
-Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
 Description: NCAR command-language library
  NCAR Command Language library used by NCAR binaries and tools.
@@ -88,7 +88,7 @@
 Package: libncarg-data
 Architecture: all
 Multi-Arch: foreign
-Depends: ${misc:Depends}
+Depends: ${misc:Depends}, ksh | mksh | pdksh | zsh
 Description: NCAR command-language library - Data
  NCAR Command Language library used by NCAR. This package contains data such
  as colormaps, fonts and map data that is used by the ncarg library.

=== debian/rules ===
--- 
+++ 
@@ -125,6 +125,19 @@
 		dh_link -p libncarg-dev $(LIBDIR)/$$d.1 $(LIBDIR)/$$d ;  done
 	cp -a debian/tmp/lib/ncarg/robj debian/libncarg-dev/$(LIBDIR)/ncarg
 	find debian -name '*.ksh' -exec chmod +x {} \;
+	# Sanitise paths for bit reproducibility
+	for f in ./debian/tmp/usr/bin/ncargcc \
+		./debian/tmp/usr/bin/ncargf77 \
+		./debian/tmp/usr/bin/ncargf90 \
+		./debian/tmp/usr/bin/nhlcc \
+		./debian/tmp/usr/bin/nhlf77 \
+		./debian/tmp/usr/bin/nhlf90 \
+		./debian/tmp/usr/bin/nclf77 \
+		./debian/tmp/usr/bin/nclf90 ; do cat $$f | \
+		 sed -e 's%${CURDIR}%/build/ncl-ncarg%g'  \
+                        > debian/tmpff ; \
+		mv debian/tmpff $$f ; \
+		done
 
 override_dh_auto_clean:
 	find . -name '*.so.1' -delete

## ncl 6.6.2

=== debian/changelog ===
ncl (6.6.2-7) unstable; urgency=medium

  * Fix broken symlinks. Closes: #986460

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 Apr 2021 14:56:37 +0100

ncl (6.6.2-6) unstable; urgency=medium

  * Typo in d/rules breaks mipsel build
  * Point Vcs-Git in d/control to debian/latest

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 17 Oct 2020 09:31:42 +0100

ncl (6.6.2-5) unstable; urgency=medium

  * Fix regression: *.a included in both -dev pkgs. Closes: #970654

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 24 Sep 2020 14:59:55 +0100

ncl (6.6.2-4) unstable; urgency=medium

  * Don't call dwz on mipsel: causes FTBFS

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 20 Sep 2020 10:10:49 +0100

ncl (6.6.2-3) unstable; urgency=medium

  * Use external spherepack lib now it has double-precision support
  * Set d/gbp.conf to point to the new DEP-14 branch names
  * Ensure fortran/$(FC) page is in libdir path in d/rules
  * Fix bug in gfortran-10 conditional that FTBFS. Closes: #966872
  * patch gcc10.patch for invalid BOZ constants. 
  * Move to debhelper level 13
  * Add -Wl,-z,muldefs , needed for stricter ld linking
  * Add d/not-installed; install extra manpages due to dh_missing audit

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 17 Sep 2020 21:38:22 +0100

ncl (6.6.2-2) unstable; urgency=medium

  * Standards-Version: 4.5.0
  * Use debhelper-compat (=12)
  * Use external spherepack lib
  * Drop flang dependency for now 
  * Enable -fallow-invalid-boz,  -fallow-argument-mismatch 
    with gfortran-10. Closes: #957583
  * Drop obsolete libxgks-dev in d/control 

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 04 May 2020 14:49:03 +0100

ncl (6.6.2-1) unstable; urgency=medium

  * New upstream release
  * drop-mod-file.patch to compile
  * format-security.patch to fix format-security errors
  * Build-Depend on gfortran | fortran-compiler
  * Change fortran compiler refs in d/rules to f95
  * Set fortran flags (no-range-check, etc.) for gfortran only in d/rules
  * Remove hard-coded 'xz'compression
  * Set ACCEPT_USE_OF_DEPRECATED_PROJ_API_H=1 in CFLAGS for proj 6.0.0
    transition.

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 23 Jun 2019 11:07:04 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: science
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper (>= 10), 
+Build-Depends: debhelper-compat (= 13), 
  flex, 
  bison, 
- gfortran, 
+ gfortran | fortran-compiler, 
  zlib1g-dev, 
  libbz2-dev, 
  libxt-dev,
@@ -26,7 +26,7 @@
  liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
  libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
  libgrib2c-dev, 
- libsphere-dev, 
+ libsphere-dev (>= 3.3~a1), 
  libhdf4-alt-dev, 
  libhdfeos-dev,
  libgctp-dev, 
@@ -37,10 +37,10 @@
  libaec-dev,
  libfl-dev, 
  libgsl-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Homepage: https://www.ncl.ucar.edu/
 Vcs-Browser: https://salsa.debian.org:/science-team/ncl.git
-Vcs-Git: https://salsa.debian.org:/science-team/ncl.git
+Vcs-Git: https://salsa.debian.org:/science-team/ncl.git -b debian/latest
 
 Package: ncl-ncarg
 Architecture: any
@@ -71,7 +71,8 @@
 Package: libncarg-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libncarg0 (= ${binary:Version} ), libxgks-dev, libudunits2-dev,
+Depends: ${misc:Depends}, libncarg0 (= ${binary:Version} ), libudunits2-dev,
+ libsphere-dev, libhdf4-alt-dev, 
  ncl-ncarg, ksh | mksh | pdksh | zsh
 Multi-Arch: same
 Description: Development files for the NCAR command language library

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

# The magic debhelper  rule
%:
	dh $@ 

DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

DO_FLANG:=$(if $(wildcard /usr/bin/flang),true, false)

GF10_FLAGS:=$(if $(filter $(shell readlink /usr/bin/gfortran), gfortran-10), \
                 -fallow-invalid-boz -fallow-argument-mismatch, )

# For the config file. Done this way to pull in stuff from hardening, etc.
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) -DACCEPT_USE_OF_DEPRECATED_PROJ_API_H=1
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
# LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
LDFLAGS:= 
FFLAGS=$(shell dpkg-buildflags --get FFLAGS) $(GF10_FLAGS)
CC ?= cc


# FC set to f77 by default in make
# Read default compiler name unless FC is actually set
ifeq ($(F77),f77)
  F77:=$(shell basename $(shell readlink /etc/alternatives/f77))
endif

ifneq ($(filter flang,$(F77)),)
FFLAGS:=$(shell dpkg-buildflags --get FFLAGS |  sed -e 's/-g //')
CTOFLIBS:= -lm
endif
ifneq ($(filter gfortran,$(F77)),)
# export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
FFLAGS:=$(FFLAGS) -fno-second-underscore -fno-range-check
CTOFLIBS:= -lgfortran -lm
endif

ifneq ($(wildcard /usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial/libhdf5.so),)
  CFLAGS += -I/usr/include/hdf5/serial
  export HDF5_LDFLAGS := -Wl,-L/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/serial
endif

export LD_LIBRARY_PATH=$(CURDIR)/shared:$(LIBDIR)/fortran/$(F77):$(LIBDIR)/libfakeroot

# We built it twice: first shared, to get the shared libraries (with -fpic -fPIC)
# then static, for execution speed.

LIBS:= \
	libNGcgm.so  libNGctrans.so   libNGgksPDF.so  libNGgksX.so     libNGlluC.so  libNGmisc2.so  libNGncl.so \
	libNGcn.so   libNGff.so       libNGgksPS.so   libNGhlu.so      libNGllu.so   libNGmisc.so   libNGnfp.so \
	libNGc.so    libNGgksCTXT.so  libNGgks.so     libNGictrans.so  libNGmath.so  libNGmp.so     libNGras.so \
	libfftpack5_dp.so  libNGnfpfort.so 

# Add extra libs to ensure all shared libs link
EXTRA_LIBS:= -lpng -lz -lX11 -lcairo -lsphere-$(F77)

# This done here to avoid subsitution bug on broken ymake buildsystem
INCS="-I/usr/include/freetype2 -I/usr/include/gdal  -I/usr/include/hdf-eos5 -I/usr/include/hdf -I/usr/include/${DEB_HOST_MULTIARCH}/hdf -I/usr/include/mpi"

override_dh_auto_configure:
	sed -e 's,@LIBDIR@,$(LIBDIR),' \
	    -e 's/@PREFIX@/\/usr/' \
	    -e 's/@VERSION@/$(UPSTREAM_VERSION)/' \
	< debian/ncarg.pc.in > ncarg.pc
	sed -e 's%@CC@%${CC}%' \
	    -e 's%@FC@%${FC}%' \
	    -e 's%@LD@%${CC}%' \
	    -e 's%@CFLAGS@%${CFLAGS}%' \
	    -e 's%@FFLAGS@%${FFLAGS}%' \
	    -e 's%@CTOFLIBS@%${CTOFLIBS}%' \
	    -e 's%@CPPFLAGS@%${CPPFLAGS}%' \
	    -e 's%@LDFLAGS@%${LDFLAGS}%' \
	    -e 's%@DESTDIR@%${DESTDIR}%' \
	< debian/Site.local.shared.in > config/Site.local.shared
	sed -e 's%@CC@%${CC}%' \
	    -e 's%@FC@%${FC}%' \
	    -e 's%@LD@%${CC}%' \
	    -e 's%@CFLAGS@%${CFLAGS}%' \
	    -e 's%@FFLAGS@%${FFLAGS}%' \
	    -e 's%@CTOFLIBS@%${CTOFLIBS}%' \
	    -e 's%@CPPFLAGS@%${CPPFLAGS}%' \
	    -e 's%@LDFLAGS@%${LDFLAGS}%' \
	    -e 's%@DESTDIR@%${DESTDIR}%' \
	< debian/Site.local.static.in > config/Site.local.static
	sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%' \
	< config/Project > config/Project.post
	mv config/Project.post config/Project 

override_dh_auto_build:
	cp config/Site.local.shared config/Site.local
	cp debian/LINUX.DEBIAN.$(F77) config/LINUX
	ln -sf LINUX config/DEBIAN
	echo 'n' | ./Configure -v
	$(MAKE) Makefiles includes depend
	# Static libraries need to be built first
	# Add symlink for non-Linux archs
	cp config/Site.local.static config/Site.local
	echo 'n' | ./Configure -v
	$(MAKE) Makefiles includes depend
	for d in common external ngmath/src/lib ncarg2d/src/libncarg_gks ncarg2d/src/libncarg ncarg2d/src/liboptional  ncarview ni/src/lib ; do \
		$(MAKE) -C $$d install INCSEARCH=${INCS} INC_SEARCH=${INCS} ; done
	LD_LIBRARY_PATH=$(DESTDIR)/lib:$(LIBDIR)/fortran/$(F77) $(MAKE) install INCSEARCH=${INCS} INC_SEARCH=${INCS} 
	# Install them safely in $(DESTDIR) as originals will be removed making shared libs
	mkdir -p $(DESTDIR)/staticlibs
	mv $(DESTDIR)/lib/*.a $(DESTDIR)/staticlibs
	$(MAKE) clean
	find . -name '*.[o]' -delete
	# Shared libraries next, in the right order.
	cp config/Site.local.shared config/Site.local
	echo 'n' | ./Configure -v
	$(MAKE) Makefiles includes depend
	for d in common external ngmath/src/lib ncarg2d/src/libncarg_gks ncarg2d/src/libncarg ncarg2d/src/liboptional  ncarview ni/src/lib/nfpfort  ni/src/lib ; do \
		LD_LIBRARY_PATH=$(DESTDIR)/lib:$(LIBDIR)/fortran/$(F77):$(CURDIR)/shared $(MAKE) -C $$d install \
			DEV_SYS_LIBS=$(EXTRA_LIBS)   INCSEARCH=${INCS} INC_SEARCH=${INCS}; done
	# Then build all the rest
	LD_LIBRARY_PATH=$(DESTDIR)/lib:$(LIBDIR)/fortran/$(F77):$(CURDIR)/shared $(MAKE) Everything \
		DEV_SYS_LIBS=$(EXTRA_LIBS) INCSEARCH=${INCS} INC_SEARCH=${INCS} LD_REL="ld -zmuldefs" LIBSEARCH=-L$(LIBDIR)/hdf5/serial/lib
	mv $(DESTDIR)/staticlibs/* $(DESTDIR)/lib

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/libncarg-dev/$(LIBDIR)/ncarg
	# TODO: These may not be present on mips64el. 
	mkdir -p debian/libncarg-data/usr/share/ncarg/nug
	[ -d $(DESTDIR)/lib/ncarg/fontcaps ]   && cp -a $(DESTDIR)/lib/ncarg/fontcaps debian/libncarg-data/usr/share/ncarg || true
	[ -d $(DESTDIR)/lib/ncarg/nclex/nug  ] && cp -a $(DESTDIR)/lib/ncarg/nclex/nug debian/libncarg-data/usr/share/ncarg/nug || true
	cp $(DESTDIR)/lib/*.a debian/libncarg-dev/$(LIBDIR)/ncarg
	find debian -name '*.ksh' -exec chmod +x {} \;
	# Sanitise paths for bit reproducibility
	for f in $(DESTDIR)/usr/bin/ncargcc \
		 $(DESTDIR)/usr/bin/ncargf77 \
		 $(DESTDIR)/usr/bin/ncargf90 \
		 $(DESTDIR)/usr/bin/nhlcc \
		 $(DESTDIR)/usr/bin/nhlf77 \
		 $(DESTDIR)/usr/bin/nhlf90 ; do cat $$f | \
		 sed -e 's%${CURDIR}%/build/ncl-ncarg%g'  \
                        > debian/tmpff ; \
		mv debian/tmpff $$f ; \
		done

override_dh_auto_clean:
	find . -name '*.so.1' -delete
	find . -type l -delete
	find . -name '*.o' -delete
	rm -f ncarg.pc config/Site.local.* config/DEBIAN
ifneq ($(wildcard config/LINUX.ORIG),)
	mv config/LINUX.ORIG config/LINUX
endif

ifneq (,$(filter $(DEB_BUILD_ARCH),mipsel alpha))
override_dh_dwz:
	@echo bypass dwz that causes build failues
endif
